import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import javax.swing.ImageIcon;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

public class Controls extends JPanel implements Observer
{
  private Model model;
  private JSlider rating;
  private JRadioButton grid;
  private JRadioButton list;
  private BufferedImage starImg;
  private BufferedImage gridImg;
  private BufferedImage listImg;
  private ImageIcon starIcon;
  private ImageIcon gridIcon;
  private ImageIcon listIcon;

  // Bob the Builder this shit
  public Controls(Model model)
  {
    // Hook up this observer so that it will be notified when the model
    // changes.
    this.model = model;
    this.setBackground(Color.cyan);
    this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
    this.setPreferredSize(new Dimension(1280,75));
    this.setMinimumSize(new Dimension(320, 75));
    
    try
    {
      this.starImg = ImageIO.read(new File("src/main/resources/star.png"));
    } catch(IOException e) {}

    try
    {
      this.gridImg = ImageIO.read(new File("src/main/resources/grid.png"));
    } catch(IOException e) {}

    try
    {
      this.listImg = ImageIO.read(new File("src/main/resources/list.png"));
    } catch(IOException e) {}
    
    this.starIcon = new ImageIcon(starImg);
    this.gridIcon = new ImageIcon(gridImg);
    this.listIcon = new ImageIcon(listImg);
    
    this.grid = new JRadioButton(gridIcon, true);
    grid.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        
      }
    });
    
    this.list = new JRadioButton(listIcon, false);
    list.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        
      }
    });
    
    this.rating = new JSlider(0, 5, 0);
    rating.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e)
      {
        model.changeFilter(rating.getValue());
      }
    });
    this.rating.setPreferredSize(new Dimension(280, 75));

    this.add(grid);
    this.add(list);
    this.add(rating);
    model.addObserver(this);
  }

  public void update(Object observable)
  {
    revalidate();
    repaint();
  }
}
