import java.util.Observable;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.io.*;

public class Model extends Observable
{
   /** The observers that are watching this model for changes. */
  private ArrayList<Observer> observers;
  private ArrayList<PicData> pics;
  private int filter;
  private boolean grid;

  // Constructor
  public Model()
  {
    this.observers = new ArrayList();
    this.pics = new ArrayList();
    this.filter = 0;
    this.grid = true;
    setChanged();
  }
  
  public void newPic()
  {
    PicData temp = new PicData();
    pics.add(temp);
    setChanged();
    notifyObservers();
  }
  
  public void changeFilter(int x)
  {
    this.filter = x;
    setChanged();
    notifyObservers();
  }
  
  public void switchLayout()
  {
    grid = !grid;
    setChanged();
    notifyObservers();
  }

  // Add observer to be notified on change
  public void addObserver(Observer observer)
  {
    this.observers.add(observer);
  }

  // Remove an observer from opdate list
  public void removeObserver(Observer observer)
  {
    this.observers.remove(observer);
  }

   // Notify all observers shit went down
  public void notifyObservers()
  {
    for (Observer observer: this.observers)
    {
      observer.update(this);
    }
  }
}

class PicData
{
  private int rating;

  public PicData()
  {
    this.rating = 0;
  }
  
  public void setRating(int x)
  {
    this.rating = x;
  }
}
